//--------------------------------------------------------------------
//                                                                    
//  Module:       SimpleEmail                                       
//  Description:  SimpleEmail
//                                                                    
//--------------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class SimpleEmail extends JDPClassLayout  {

	JDPUser user;
	JDPJagg jaggSQL;
	JDPPopupMessage popuppanel;
	JDPMaskEdit JDPMaskEditMain;
	String moduleParameter;
	//
	//  Declare screen components
	//
	Panel Main;
	TextArea messageText;
	JDPScrollPanel ScrollPanel1;
	Label Label1;
	TextField mailServer;
	Label Label2;
	TextField toAddress;
	Label Label3;
	TextField messageSubject;
	Label Label4;
	TextField fromAddress;
	JDPButtons JDPButtons1;
	JDPEmailSender EMail1;

	public void InitClass(JDPUser user, Panel targetPanel, String moduleParameter) {

		this.user = user;
		this.moduleParameter = moduleParameter;
		//
		//  Set JAGG settings for this class
		//
		jaggSQL = new JDPJagg(user.jaggPath);

		setLayout(new BorderLayout());
		popuppanel = new JDPPopupMessage(user,this);
		add(popuppanel);
		JDPMaskEditMain = new JDPMaskEdit();

		Main = new Panel();
		messageText = new TextArea("", 3,20);
		ScrollPanel1 = new JDPScrollPanel();
		Label1 = new Label("Mail Server:", Label.LEFT);
		mailServer = new TextField("mail", 30);
		Label2 = new Label("To:", Label.LEFT);
		toAddress = new TextField("", 30);
		Label3 = new Label("Subject:", Label.LEFT);
		messageSubject = new TextField("", 30);
		Label4 = new Label("From:", Label.LEFT);
		fromAddress = new TextField("", 30);
		String[] JDPButtons1btns = {"Send Message"};
		int[] JDPButtons1icns = {JDPButton.getIconValue("Email")};
		JDPButtons1 = new JDPButtons(user, JDPButtons1btns, JDPButtons1icns, JDPButtons.getAlignmentValue("Horizontal"));
		EMail1 = new JDPEmailSender(user);

		Main.setLayout(new BorderLayout());
		add("Center", Main);
		Main.add("Center", messageText);
		Main.add("North", ScrollPanel1);
		ScrollPanel1.add("Left", Label1);
		ScrollPanel1.add("Right", mailServer);
		ScrollPanel1.add("Left", Label2);
		ScrollPanel1.add("Right", toAddress);
		ScrollPanel1.add("Left", Label3);
		ScrollPanel1.add("Right", messageSubject);
		ScrollPanel1.add("Left", Label4);
		ScrollPanel1.add("Right", fromAddress);
		Main.add("South", JDPButtons1);

		messageText.setFont(new Font("Helvetica", Font.PLAIN, 11));
		messageText.setForeground(user.u._cvtcolor("Black"));
		messageText.setBackground(user.u._cvtcolor("LightGray"));
		mailServer.setFont(new Font("Helvetica", Font.PLAIN, 11));
		mailServer.setForeground(user.u._cvtcolor("Black"));
		mailServer.setBackground(user.u._cvtcolor("LightGray"));
		toAddress.setFont(new Font("Helvetica", Font.PLAIN, 11));
		toAddress.setForeground(user.u._cvtcolor("Black"));
		toAddress.setBackground(user.u._cvtcolor("LightGray"));
		messageSubject.setFont(new Font("Helvetica", Font.PLAIN, 11));
		messageSubject.setForeground(user.u._cvtcolor("Black"));
		messageSubject.setBackground(user.u._cvtcolor("LightGray"));
		fromAddress.setFont(new Font("Helvetica", Font.PLAIN, 11));
		fromAddress.setForeground(user.u._cvtcolor("Black"));
		fromAddress.setBackground(user.u._cvtcolor("LightGray"));


		//
		//  Initialise Components
		//
		InitComponents();
		//
		//  Add the handle to this panel to the global vector so other panels can
		//  access this one
		//
		user.gParm.addElement(this);
	}

	//
	//  Handle screen events
	//
	public boolean handleEvent(Event e) {

		switch (e.id) {
		case Event.KEY_PRESS:
			if (e.key == '\t' && e.modifiers != Event.SHIFT_MASK) {
				if (e.target.equals(messageText)) { user.u.cursor(mailServer); return true; }
				if (e.target.equals(mailServer)) { user.u.cursor(toAddress); return true; }
				if (e.target.equals(toAddress)) { user.u.cursor(messageSubject); return true; }
				if (e.target.equals(messageSubject)) { user.u.cursor(fromAddress); return true; }
				if (e.target.equals(fromAddress)) { user.u.cursor(messageText); return true; }
			}
			if (e.key == '\t' && e.modifiers == Event.SHIFT_MASK) {
				if (e.target.equals(messageText)) { user.u.cursor(fromAddress); return true; }
				if (e.target.equals(mailServer)) { user.u.cursor(messageText); return true; }
				if (e.target.equals(toAddress)) { user.u.cursor(mailServer); return true; }
				if (e.target.equals(messageSubject)) { user.u.cursor(toAddress); return true; }
				if (e.target.equals(fromAddress)) { user.u.cursor(messageSubject); return true; }
			}
			return false;

		case Event.ACTION_EVENT:
			if (e.target.equals(JDPButtons1.button[0])) {
				EMail1.setMailServer(mailServer.getText());
				EMail1.setToAddress(toAddress.getText());
				EMail1.setMessageSubject(messageSubject.getText());
				EMail1.setReturnAddress(fromAddress.getText());
				EMail1.setMessage(messageText.getText());
				EMail1.sendSingleMessage();
				return true;
			}
			return false;

		case Event.MOUSE_MOVE:
		case Event.MOUSE_ENTER:
		case Event.MOUSE_EXIT:
			popuppanel.postEvent(e);
			return false;

		default:
			return false;

		}
	}


	//
	//  Initialise other components by calling their methods
	//
	public void InitComponents() {

		

	}

}

